Subject: Re: [Fud] Charter Text

From: Hannes Tschofenig <[email-masked]>
Date: Wed, 13 Sep 2017 16:46:52 +0200

Hi Russ,

thanks for your feedback.

A few remarks below:

On 08/14/2017 03:05 PM, Russ Housley wrote:
> I'm jumping into this conversation after vacation.  I have read the whole thread to date before composing this note.
> 
> 
>> Firmware Updating Description (FUD)
> 
> The page that Kathleen set up call this group Firmware UpDate (FUD).
> 
> 
>> Vulnerabilities with Internet of Things (IoT) devices have raised the
>> need for a secure firmware update mechanism that is also suitable for
>> constrained devices. Security experts, researchers and regulators
>> recommend that all IoT devices are equipped with such a mechanism. While
>> there are many proprietary firmware update mechanisms in use today there
>> is a lack of an modern interoperable approach of securely updating IoT
>> devices.
>>
>> A firmware update solution consists of several components, including a
>> mechanism to transport firmware images to IoT devices and a manifest
>> that provides meta-data about the firmware image as well as
>> cryptographic information for protecting the firmware image in an
>> end-to-end fashion. With RFC 4018 the IETF standardized a manifest
>> format that uses the Cryptographic Message Syntax (CMS) to protect
>> firmware packages.
> 
> There are some vital pieces of information that need to be conveyed, but from the above text, it is not clear to me whether they are expected to be in the manifest and meta-data.  The vital data includes:
> 
>    - a firmware package identifier;
>    - whether the package is a patch or upgrade;
>    - the hardware the package needs to run;
>    - dependencies on other firmware packages; and
>    - if the package is encrypted to protect intellectual property, the key needed to decrypt it.
> 
-----

The above-listed information is expected to be included in the manifest.
Maybe the paragraph should be expanded in the following way:

A firmware update solution consists of several components, including
* a mechanism to transport firmware images to IoT devices,
* a manifest that provides meta-data about the firmware image (such as a
firmware package identifier, the hardware the package needs to run,
dependencies on other firmware packages, etc.) as well as
cryptographic information for protecting the firmware image in an
end-to-end fashion, and
* the firmware image itself.
With RFC 4018 the IETF standardized a manifest format that uses the
Cryptographic Message Syntax (CMS) to protect firmware packages.

-----
Do you think that this is better text?

> 
>> Since the publication of RFC 4108 more than 10 years have passed and
>> more experience with IoT deployments have lead to additional
>> functionality requiring the work done with RFC 4108 to be revisited. The
>> purpose of this group is to standardize a version 2 of RFC 4108 that
>> reflects best current practices. This group will not define any
>> transport mechanism.
>>
>> In 2016 the Internet Architecture Board organized a workshop on
>> 'Internet of Things (IoT) Software Update (IOTSU)', which took place at
>> Trinity College Dublin, Ireland on the 13th and 14th of June, 2016. The
> 
> 13-14 June 2016
OK.

> 
>> main goal of the workshop was to foster a discussion on requirements,
>> challenges and solutions for bringing software and firmware updates to
>> IoT devices. This workshop also made clear that there are challenges
>> with lack of regulatory requirements, and misaligned incentives. It is
>> nevertheless seen as important to standardize the building blocks that
>> help interested parties to implement and deploy a solid firmware update
>> mechanism.
>>
>> In particular this group aims to publish two documents, namely
>> * an IoT firmware update architecture that includes a description of
>> the involved entities, security threats and assumptions, and
>> * the manifest format itself.
> 
> The text a few paragraphs ago made me think that rfc4108bis was an output.  Why is it not here?
> 
>> This group does not aim to standardize a generic software update
>> mechanism used by rich operating systems, like Linux, but instead
>> focuses on software development practices in the embedded industry.
> 
> This should be expanded to make it clear that JavaScript is not a goal either.
> 

Good point.

-----

This group does not aim to standardize a generic software update
mechanism used by rich operating systems, like Linux, but instead
focuses on software development practices in the embedded industry.
Software update solutions that aim to take the features of scripting
languages, such as JavaScript variants like JerryScript, into account
are also outside the scope of this group.

-----

>> This group will aim to develop a close relationship with silicon vendors
>> and OEMs that develop IoT operating systems.
>>
>> Milestones
>>
>> Dec 2017     Submit "Architecture" document as WG item.
>>
>> Dec 2017     Submit "Manifest Format" specification as WG item.
>>
>> Jul 2018    Submit "Architecture" to the IESG for publication as an
>> Informational RFC.
>>
>> Nov 2018     Submit "Manifest Format" to the IESG for publication as a
>> Proposed Standard.
> 
> The text a few paragraphs ago made me think that rfc4108bis was an output.  Why is it not here?
I didn't use the term "rfc4108bis" but instead called it "manifest format".

Ciao
Hannes

> Russ

---

From: Russ Housley <[email-masked]>
Date: Wed, 13 Sep 2017 10:52:08 -0400

Thanks for addressing my comments.

Russ

> On Sep 13, 2017, at 10:46 AM, Hannes Tschofenig <[email-masked]> wrote:
> 
> Hi Russ,
> 
> _______________________________________________
> Fud mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/fud